$(document).ready(init);

//En fonction du support, évènement click ou touchend
var _clickTouch;
var _mobile = false;

var _animLance = false;
var _xOrigin, _yOrigin;
var _intensiteInit = '0,10';
var _angleInit = '45';
var _distanceInit = '20';

function init() {	
	// Si on est sur mobile ou non	
	if(navigator.userAgent.match("Mobile") || navigator.userAgent.match("Android"))
		_mobile = true;
	
	if(_mobile)
		$('.inputText').css('width', '30px');
	
	// Evenement click si on se trouve sur PC et touchend sur mobile
	_clickTouch = ((_mobile == true) ? "touchend" : "click");
	
	$('img').bind('mousedown', function(){
		return false;
	});
	
	$('#ecran2').hide();
	_xOrigin = $('#ligneFleche').position().left;
	_yOrigin = $('#ligneFleche').position().top;
	
	$('.inputText').removeAttr('disabled');
	traceAnimation(parseFloat(_intensiteInit.replace(',', '.')), parseInt(_angleInit), parseInt(_distanceInit));
	
	$('#btnExercice').bind(_clickTouch, function(){
		exoInit();
	});
	$('.inputText').focusin(function(){
		$(this).val('');
	});
	$('.inputText').focusout(function(){
		if(validInfos()){
			var force = parseFloat($('#intensiteVal').val().replace(',', '.').replace(' ', ''));
			var angle = parseInt($('#angleVal').val().replace(' ', ''));
			var distance = parseInt($('#distanceVal').val().replace(' ', ''));
			traceAnimation(force, angle, distance);
		}
	});
	$('#btnLancer').bind(_clickTouch, function(){
		if(validInfos()){
			var force = parseFloat($('#intensiteVal').val().replace(',', '.').replace(' ', ''));
			var angle = parseInt($('#angleVal').val().replace(' ', ''));
			var distance = parseInt($('#distanceVal').val().replace(' ', ''));
			traceAnimation(force, angle, distance);
			lanceAnim();
		}
	});
	$('#btnRestart').bind(_clickTouch, function(){
		if(_animLance && _animFinished){
			_animLance = false;	
			_animFinished = false;	
			$('#arcAngle').show();
			$('#alpha').show();
			$('#ligneFleche').css({
				left: $('#ligneFleche').position().left-$('#droiteAB').width()+'px'
			});
			$('#pointeFleche').css({
				left: $('#pointeFleche').position().left-$('#droiteAB').width()+4+'px'
			});
			if(parseFloat($('#intensiteVal').val()) < 0.04){
				$('#lignePointilles').css({
					left: '315px'
				})
			}
			$('#pointP').css({
				left: $('#pointP').position().left-$('#droiteAB').width()+'px'
			});
			$('#lettreF').css({
				left: $('#lettreF').position().left-$('#droiteAB').width()+'px'
			});
			$('.inputText').removeAttr('disabled');
			$('.inputText').css('background-color', 'white');
			$('#jouleVal').val('...');
			
			$('#intensiteVal').val(_intensiteInit);
			$('#angleVal').val(_angleInit);
			$('#distanceVal').val(_distanceInit);
			traceAnimation(parseFloat(_intensiteInit.replace(',', '.')), parseInt(_angleInit), parseInt(_distanceInit));
		}
	});
}
function exoInit(){
	$('#ecran1').hide();
	$('#ecran2').show();
	$('#error').hide();	
	$('#intensiteVal').val(_intensiteInit);
	$('#angleVal').val(_angleInit);
	$('#distanceVal').val(_distanceInit);
	$('#jouleVal').val('...');
}
function traceAnimation(intensite, angle, distance){
	$('#lignePointilles').hide();
	$('#droiteAB').css({
		width: distance*19.95+'px'
	});
	$('#pointB').css('left', $('#droiteAB').position().left+$('#droiteAB').width()-3+'px');
	angleRotate = -angle;
	
	$('#ligneFleche').css({
		width: intensite*1800+'px',
		transform: 'rotate('+angleRotate+'deg)',
		'-webkit-transform': 'rotate('+angleRotate+'deg)',
		'-moz-transform': 'rotate('+angleRotate+'deg)',
		'-ms-transform': 'rotate('+angleRotate+'deg)',
	});
	$('#lignePointilles').css({
		transform: 'rotate('+angleRotate+'deg)',
		'-webkit-transform': 'rotate('+angleRotate+'deg)',
		'-moz-transform': 'rotate('+angleRotate+'deg)',
		'-ms-transform': 'rotate('+angleRotate+'deg)',
	});
	if(intensite < 0.04)
		$('#lignePointilles').show();
	
	var x2 = _xOrigin + Math.cos(angleRotate*Math.PI/180) * $('#ligneFleche').width();
    var y2 = _yOrigin + Math.sin(angleRotate*Math.PI/180) * $('#ligneFleche').width();
	console.log(x2+" ; "+y2);
	decalageTop = 0;
	if(angle < 41)
		decalageTop = 1;
	$('#pointeFleche').css({
		transform: 'rotate('+angleRotate+'deg)',
		'-webkit-transform': 'rotate('+angleRotate+'deg)',
		'-moz-transform': 'rotate('+angleRotate+'deg)',
		'-ms-transform': 'rotate('+angleRotate+'deg)',
		left: x2-4+'px',
		top: y2-($('#pointeFleche').height()/2)+decalageTop+'px'
	});
	//$('#test').text($('#pointeFleche').css('top'));
	$('#arcAngle').show();	
	if(angle < 85){
		$('#arcAngle').css({
			height: angle+'px',
		});
	}
	else if(angle == 0){
		$('#arcAngle').hide();	
	}
	else{
		$('#arcAngle').css({
			height: angle+10+'px',
		});	
	}
	$('#arcAngle').css({
		top:	$('#pointA').position().top-$('#arcAngle').height()+'px'
	});
	$('#lettreF').css({
		left: $('#pointeFleche').position().left-20+'px',
		top: $('#pointeFleche').position().top-20+'px',
	});
}
function lanceAnim(){
	if(!_animLance){
		_animLance = true;
		_animFinished = false;
		$('#arcAngle').hide();
		$('#alpha').hide();
		
		$('.inputText').attr('disabled', 'disabled');
		$('.inputText').css('background-color', '#fffda3');
	
		var intensite = parseFloat($('#intensiteVal').val().replace(',', '.'));
		var angle = parseInt($('#angleVal').val());
		var distance = parseInt($('#distanceVal').val());
		
		var travailForce = intensite * distance * Math.cos(angle*Math.PI / 180);
		var vitesseAnim = angle * 40;
		
		// Animation
		$('#ligneFleche').animate({
			left: $('#ligneFleche').position().left +$('#droiteAB').width()+'px'
		}, vitesseAnim, 'easeInCubic');
		$('#pointeFleche').animate({
			left: $('#pointeFleche').position().left +$('#droiteAB').width()+2+'px'
		}, vitesseAnim, 'easeInCubic');
		if(intensite < 0.04){
			$('#lignePointilles').animate({
				left: $('#lignePointilles').position().left +$('#droiteAB').width()+'px'
			}, vitesseAnim, 'easeInCubic');
		}
		$('#pointP').animate({
			left: $('#pointP').position().left +$('#droiteAB').width()+'px'
		}, vitesseAnim, 'easeInCubic');
		$('#lettreF').animate({
			left: $('#lettreF').position().left +$('#droiteAB').width()+'px'
		}, vitesseAnim, 'easeInCubic', function(){
			// Affichage du nombre de joules
			var travailForceStr = String((Math.round(travailForce*10))/10).replace(".", ",");
			$('#jouleVal').val(travailForceStr);
			_animFinished = true;
		});
	}
}
function validInfos(){
	var valueOK = false;
	if(!_animLance){
		var intensite = $('#intensiteVal').val().replace(',', '.').replace(' ', '');
		$('#intensiteVal').val(intensite);
		var angle = $('#angleVal').val().replace(' ', '');
		$('#angleVal').val(angle) ;
		var distance = $('#distanceVal').val().replace(' ', '');
		$('#distanceVal').val(distance);	
		$('#error').hide();
		if(!_animLance)
			$('.inputText').css('background-color', 'white');
		
		
		if(parseFloat(intensite) != 'NaN'){
			if(parseFloat(intensite) >= 0 && parseFloat(intensite) <= 0.1){
				valueOK = true;
				$('#intensiteVal').val($('#intensiteVal').val().replace('.', ','))	
			}
			else{
				valueOK = false;
				$('#intensiteVal').css('background-color', 'red');
				$('#error').show();
				$('#error').css('top', '245px');
			}
		}
		else{		
			valueOK = false;
			$('#intensiteVal').css('background-color', 'red');
			$('#error').show();
			$('#error').css('top', '245px');
		}
		if(parseInt(angle) != 'NaN'){
			if(parseInt(angle) >= 0 && parseInt(angle) <= 90){
				valueOK = true;
			}
			else{
				valueOK = false;
				$('#angleVal').css('background-color', 'red');
				$('#error').show();
				$('#error').css('top', '315px');
			}
		}
		else{
			valueOK = false;
			$('#angleVal').css('background-color', 'red');
			$('#error').show();
			$('#error').css('top', '315px');
		}
		if(parseInt(distance) != 'NaN'){
			if(parseInt(distance) >= 0 && parseInt(distance) <= 20){
				valueOK = true;
			}
			else{
				valueOK = false;
				$('#distanceVal').css('background-color', 'red');
				$('#error').show();
				$('#error').css('top', '395px'); 
			}
		}
		else{
			valueOK = false;
			$('#distanceVal').css('background-color', 'red');
			$('#error').show();
			$('#error').css('top', '395px'); 	
		}
	}
	return valueOK;
}